## diffoscope 93ubuntu1

=== doc/Makefile ===
#!/usr/bin/make -f
# This file is also present in reprotest, please update that as well if you
# make fixes here.

PACKAGE = diffoscope
VERSION = $$(cd .. && python3 setup.py -V)
SED_fix_package_quirks = -e 's,bin/diffoscope,diffoscope,g'

SED_rm_python_usage_msg = -e '/end_of_description_header/,/positional arguments/{d}'
SED_fix_rst2man_quirks = \
  -e 's,^ \\- ,,' \
  -e 's,^\[,\\[char91],g' \
  -e 's,\.TH *"" "" "",,g'
SED_rst2man_output_to_h2m_input = \
  -e 's,\.SH \(.*\),[\1],g' \
  -e 's,\[$(PACKAGE)\],[DESCRIPTION],gi'

all: $(PACKAGE).1

$(PACKAGE).1: $(PACKAGE).h2m ../$(PACKAGE)/__init__.py
	help2man --version-string=$(VERSION) ../bin/$(PACKAGE) -N --include="$<" | \
	  sed $(SED_rm_python_usage_msg) > "$@"

$(PACKAGE).h2m: $(PACKAGE).h2m.0 ../README.rst Makefile
	{ cat $(PACKAGE).h2m.0; cat ../README.rst | \
	  rst2man -q --no-doc-title | \
	  sed $(SED_fix_rst2man_quirks) \
	      $(SED_fix_package_quirks) \
	      $(SED_rst2man_output_to_h2m_input); } > "$@"

.PHONY: clean
clean:
	$(RM) $(PACKAGE).1 $(PACKAGE).h2m

## diffoscope 33

=== debian/changelog ===
diffoscope (33) unstable; urgency=medium

  * Fix path to diffoscope used to generate Recommends. (Closes: #797978)

 -- Jérémy Bobbio <lunar@debian.org>  Fri, 04 Sep 2015 10:20:45 +0200

diffoscope (32) unstable; urgency=medium

  [ Jérémy Bobbio ]
  * Add `--fuzzy-threshold` option. This allows one to specify the TLSH score
    used as cut-off for fuzzy matching. Specifying 0 will disable
    fuzzy-matching entirely. Thanks Jakub Wilk for prompting me to implement
    this. (Closes: #797557)
  * Add `--new-file` to treat absent files as empty. Thanks Jakub Wilk for the
    suggestion. (Closes: #797560)
  * Enable comparisons of symlinks and devices given on the command line.
    (Closes: #796262)
  * Fix comparisons of device files. (Closes: #796288)
  * Perform comparisons of file metadata in directories using original path.
    (Closes: #796202)
  * Display default values in `--help`.
  * Stop unpacking Tar directories. Thanks h01ger for the report.
    (Closes: #797164)
  * Make directory comparison work again.
  * Fix and document required Python modules. Thanks plntyk for the feedback on
    IRC.
  * Pass `--force-local`. to cpio. We don't want filenames with ':' to trigger
    remote copies.
  * Mark that get_ar_content() as requiring the 'ar' executable.
  * Rework how diffoscope main() is run. Thanks Yaroslav Halchenko for the
    report and suggestions. (Closes: #796196)
  * Assume UTF-8 output if stdin does not advertise any encoding.
  * Give proper error message when run on non-existing files.
  * Output differences in directory test to ease debugging.
  * Update manpage. Thanks Jakub Wilk for reporting the issue.
    (Closes: #797561)
  * Properly handle SIGTERM and do cleanup temp files. Thanks Mattia Rizzolo
    for reporting this and how he did work around this deficiency.
    (Closes: #788568)
  * Fix handling of GHC .hi file (Closes: #796039)
  * Add a test on how Ctrl+C is handled.
  * Minor code improvements.

  [ Chris Lamb ]
  * Correct "comment" on Device comparator.

 -- Jérémy Bobbio <lunar@debian.org>  Thu, 03 Sep 2015 20:00:45 +0200

diffoscope (31) unstable; urgency=low

  [ Reiner Herrman ]
  * Fix detection of jar archives.
  * Make some hardcoded limits configurable. (Closes: #795292)

  [ Mattia Rizzolo ]
  * Don't print the traceback when killed by KeyboardInterrupt.
  * Add a --debugger option to dump the user into pdb in case of crashes.
    (Closes: #796204)

  [ Jérémy Bobbio ]
  * Replace ssdeep by tlsh

  [ Chris Lamb ]
  * Unify to 4 spaces everywhere.
  * Leave string interpolation to logging.$level(..) calls.
  * Add missing 'sys' import.
  * Specify source of 'Files' correct; was using "Changes" leaked from for loop.
  * Remove unused and duplicate imports.
  * Support passing directories as "foo/" or "foo".

 -- Jérémy Bobbio <lunar@debian.org>  Fri, 21 Aug 2015 00:03:11 +0200

diffoscope (30) unstable; urgency=low

  * Remove empty line at the beginning of HTML reports.
  * Stop failing to run the tests when uid 1000 doesn't exist.
  * Make .changes file matching more accurate.
  * Move the sanity check for version number from clean to build rule.
  * Remove leftover debug in squashfs comparator.
  * Stop decompressing squashfs directories as we compare content already.

 -- Jérémy Bobbio <lunar@debian.org>  Sun, 09 Aug 2015 12:18:30 +0200

diffoscope (29) unstable; urgency=low

  [ Reiner Herrmann ]
  * Prevent empty line at the end of squashfs listing.

  [ Jérémy Bobbio ]
  * Rename to diffoscope. debbindiff has grown way beyond a being just a tool
    to compare Debian packages. Let's rename it to better reflect this state of
    things.
  * Add a favicon to HTML reports.
  * Always use pybuild in debian/rules.

 -- Jérémy Bobbio <lunar@debian.org>  Mon, 03 Aug 2015 15:55:07 +0200

debbindiff (28) unstable; urgency=low

  * Improve code quality by storing comments for Difference as lists.
  * Fix label for content of gzip, bzip2, and xz files.
  * Handle when only the encoding is different when comparing text files.
    (Closes: #794347)

 -- Jérémy Bobbio <lunar@debian.org>  Sun, 02 Aug 2015 17:21:52 +0200

debbindiff (27) unstable; urgency=low

  [ Reiner Herrmann ]
  * Add dh-python to Build-Depends.

  [ Daniel Kahn Gillmor ]
  * Add support for Mono PE executables.

  [ Holger Levsen ]
  * Add myself to Uploaders.

  [ Jérémy Bobbio ]
  * Add tests for tar comparator.
  * Massive rearchitecturing.
  * Now use libarchive to handle cpio archives and iso9660 images.
  * find is now used to compare directory listings.
  * Symlinks and devices can now be properly compared. (Closes: #789003)
  * Files in squashfs are now extracted one by one.
  * Text files are now compared after being decoded with the detected
    encoding. Encoding differences are reported. (Closes: #785777)
  * Pre-compile regexps for ELF archives to get a good performance gain
    when comparing ELF objects.
  * Display better stacktrace for functions and methods using decorators.
  * Reset locale environment during tests.
  * Use numeric uid/gid when listing cpio content.
  * Set timezone to UTC when configuring locale.
  * Return no differences when there's none even when a required tool is
    unavailable.
  * Fix rpm expected listing after cpio change.
  * Skip tests when required tools are missing.
  * Skip squashfs listing test until #794096 is solved.
  * Analyze md5sums in .deb and skip identical files.
  * Add support for sqlite3 databases.
  * Implement fuzzy-matching of files in the same container using ssdeep.
  * Add pydist-overrides for magic and rpm.
  * When comparing .changes, match names without version numbers.
  * Switch to pybuild as dh buildsystem.

 -- Jérémy Bobbio <lunar@debian.org>  Fri, 31 Jul 2015 08:38:10 +0000

debbindiff (26) unstable; urgency=low

  * Declare the package autopkgtestable.
  * Fix comparator for unknown files.
  * Add tests for unknown files comparator.



=== debian/control ===
Source: diffoscope
Section: devel
Priority: optional
Maintainer: Reproducible builds folks <reproducible-builds@lists.alioth.debian.org>
Uploaders: Jérémy Bobbio <lunar@debian.org>,
 Reiner Herrmann <reiner@reiner-h.de>,
 Holger Levsen <holger@debian.org>
Build-Depends: debhelper (>= 9),
               dh-python,
               python-all,
               python-debian,
               python-docutils,
               python-libarchive-c,
               python-magic,
               python-pytest,
               python-rpm,
               python-setuptools,
               python-tlsh,
               rpm-common
Standards-Version: 3.9.6
X-Python-Version: >= 2.7
Homepage: http://diffoscope.org/
Vcs-Git: git://anonscm.debian.org/reproducible/diffoscope.git
Vcs-Browser: https://anonscm.debian.org/cgit/reproducible/diffoscope.git
XS-Testsuite: autopkgtest

Package: diffoscope
Architecture: all
Depends: ${misc:Depends},
         ${python:Depends},
Recommends: ${diffoscope:Recommends}
Breaks: debbindiff (<< 29)
Replaces: debbindiff (<< 29)
Description: in-depth comparison of files, archives, and directories
 diffoscope will try to get to the bottom of what makes files or directories
 different. It will recursively unpack archives of many kinds and transform
 various binary formats into more human readable form to compare them. It can
 compare two tarballs, ISO images, or PDF just as easily. The differences can
 be shown in a text or HTML report.
 .
 diffoscope is developed as part of the “reproducible builds” Debian
 project and was formerly known as “debbindiff”.

Package: debbindiff
Depends: diffoscope, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed once
 callers have been update to use 'diffoscope' instead of 'debbindiff'.

=== debian/rules ===
#!/usr/bin/make -f

VERSION = $(shell dpkg-parsechangelog --show-field Version)

%:
	dh $@ --with python2 --buildsystem=pybuild

override_dh_auto_build:
	@if ! grep -q 'VERSION = "$(VERSION)"' diffoscope/__init__.py; then \
		echo "Version in debian/changelog doesn't match diffoscope version"; \
		exit 1; \
	fi
	dh_auto_build -O--buildsystem=pybuild

override_dh_gencontrol:
	TOOLS="$$(bin/diffoscope --list-tools | tail -n 1 | \
		sed -e 's/\(^\| \)\(coreutils\|diffutils\|e2fsprogs\|findutils\|gzip\)\(,\|$$\)//g')"; \
		[ -n "$$TOOLS" ] || { echo '--list-tools failed' >&2; exit 1; }; \
		echo "diffoscope:Recommends=$$TOOLS" >> debian/diffoscope.substvars
	dh_gencontrol -O--buildsystem=pybuild

debian/diffoscope.1: debian/diffoscope.1.rst
	rst2man $< $@

override_dh_installman: debian/diffoscope.1
	dh_installman -O--buildsystem=pybuild

override_dh_clean:
	rm -f debian/diffoscope.1
	dh_clean -O--buildsystem=pybuild

diffoscope/presenters/icon.py: favicon.png
	(echo '# Generated from favicon.png'; \
	 echo 'FAVICON_BASE64 = """'; \
	 base64 $<; \
	 echo '""".replace("\\n", "")'; \
	) > $@

favicon.png: logo.svg
	inkscape -w 32 -h 32 -e $@ $<

=== debian/tests/control ===
Tests: pytest
Depends: diffoscope, python-pytest
Restrictions: needs-recommends

## diffoscope 51

=== debian/changelog ===
diffoscope (51) unstable; urgency=medium

  * Team upload.
  * Re-upload, the last uploaded tarball was broken, missing test files.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 28 Feb 2016 11:56:35 +0000

diffoscope (50) unstable; urgency=medium

  [ Jérémy Bobbio ]
  * Remove myself from uploaders

  [ Reiner Herrmann ]
  * Show line ordering variation in deb md5sums
  * Reset mtimes of test directories and ignore ctimes (Closes: #815171)
  * Add comparator for Postscript files

 -- Holger Levsen <holger@debian.org>  Sat, 27 Feb 2016 19:37:20 +0100

diffoscope (49) unstable; urgency=medium

  [ Jérémy Bobbio ]
  * Don't crash when we can't find the debug file in a matching debug package.
    This repairs diffoscope for xserver-xorg and other packages.
  * Use libarchive to read metadata from ar archives. The output is more
    precise and less dependent on binutils version. The command line `ar` tool
    is not used any more so remove it from the required tools.
  * Split readelf --debug-dump output when examining ELF files. Based on a
    patch by Dhole.
  * Keep both .debug_str and .zdebug_str as ElfSection. Thanks to Niels Thykier
    for noticing the problem.
  * Fix a logic error in _install_debug_symbols. Thanks anthraxx for the report
    and the fix.
  * Use recursive containers for directory and only look at files with ending
    in .deb when looking for Build IDs. Both avoid looking at too many files
    when searching for matching debug packages. Thanks Helmut Grohne and Steven
    Chamberlain for the reports and tests. (Closes: #813052)
  * Add support for ICC profiles. This adds a Recommends on colord in Debian.
  * Harmonize spaces and commas in package list.
  * Update PPU files test data for FPC 3.0.0.
  * Update exepcted javap output for OpenJDK 1.8.
  * Stop specializing files from directories earlier than necessary.

  [ anthraxx ]
  * Adding cd-iccdump package reference for Arch Linux.

  [ Mattia Rizzolo ]
  * Use HTTPS in Vcs-Git.

  [ Holger Levsen ]
  * Bump standards version to 3.9.7, no changes needed.
  * Use /git/ instead /cgit/ in Vcs-Browser.

 -- Jérémy Bobbio <lunar@debian.org>  Wed, 17 Feb 2016 18:12:45 +0100

diffoscope (48) unstable; urgency=medium

  * Open debian/control file in binary mode (Closes: #812524)
  * Fix recognizes() for files ending in .buildinfo but without a
    Checksums-Sha256 field. (Closes: #812534)
  * Fix finding debug packages with multiple Build-Ids.
  * Cleanup how arguments are given to readelf for sections.
  * Only pass --decompress to readelf when the option is supported. This
    restores compatibility with older versions of binutils.
  * Skip dbgsym tests if the debian Python module is not available.

 -- Jérémy Bobbio <lunar@debian.org>  Tue, 26 Jan 2016 12:13:57 +0100

diffoscope (47) unstable; urgency=low

  * Don't show a difference for identical but long diff inputs (e.g. objdump
    output). This should make diffoscope run longer for large diff inputs, but
    more correct reports worths it.
  * Fix symbol ignore regexp for ELF files.
  * Ask readelf to decompress sections before dumping their content.
  * Don't redefine .name() in Archive when its already defined in File.
  * All files can now belong to a container. This will help us implement
    cross-file analysis.
  * Update requirements for ELF tests.
  * Sort file order when comparing directories.
  * Use Python OrderedDict instead of keeping a list of sections in ELF
    container.
  * Install detached symbols from debug .deb before comparing ELF files.
    This means objdump output should have line numbers for Debian packages
    built with recent debhelper as long as the associated debug package is in
    the same directory.
  * Add support for Debian .buildinfo files.

 -- Jérémy Bobbio <lunar@debian.org>  Sat, 23 Jan 2016 18:08:33 +0000

diffoscope (46) unstable; urgency=low

  [ Dhole ]
  * Improve ELF comparisons by performing comparisons section by section.
    (Closes: #808197)

  [ Jérémy Bobbio ]
  * Further split readelf output when examining ELF files.
  * Skip dumping ELF sections that are already covered by previous readelf
    calls to avoid redundant output. Thanks Mike Hommey for the report.
    (Closes: #808267)
  * Fix ELF comparisons against non-existing files.
  * Filter symbols for IP-relative ops from ELF disassembled output as
    they will create differences that don't really exist. Thanks Mike Hommey
    for the report and test cases. (Closes: #808207)
  * Add forgotten requirements for tests with non-existing files.
  * Improve tests for comparisons against non-existing files.
  * Respect order of containers when performing comparisons. It makes the
    output somewhat nicer, especially for things that are expected to be in a
    certain order, like ELF sections.
  * Fix comparisons of directory with broken symlinks. Thanks Tuomas Tynkkynen
    for reporting the issue. (Closes: #810825)

 -- Jérémy Bobbio <lunar@debian.org>  Tue, 19 Jan 2016 16:46:47 +0100

diffoscope (45) unstable; urgency=medium

  [ Rainer Müller ]
  * Fix typo in Mach-O comparator.

  [ Jérémy Bobbio ]
  * Ensure that we always get path names from libarchive as str.
    (Closes: #808541)
  * Read ext4 reference diff using UTF-8 to ensure that the test suite
    works when run under various locales.
  * Replace file path by a fixed placeholder in readelf and objdump output.
    This will work better when comparing ELF files given on the command line.
  * Read lines using an iterator instead of loading a full list in memory.
    This greatly help diffoscope when running on large binaries. Thanks Mike
    Hommey for the report and good test case. (Closes: #808120)
  * Properly report lines we can't parse in squashfs listing.
  * Correctly parse squashfs device entries with device minors larger than 3
    digits. Thanks sajolida for providing the samples.
  * Use libarchive to list files in tar and cpio archives. The output of cpio


=== debian/control ===
Source: diffoscope
Section: devel
Priority: optional
Maintainer: Reproducible builds folks <reproducible-builds@lists.alioth.debian.org>
Uploaders:
 Reiner Herrmann <reiner@reiner-h.de>,
 Holger Levsen <holger@debian.org>
Build-Depends: binutils-multiarch,
               debhelper (>= 9),
               dh-python,
               python3-all,
               python3-debian,
               python3-docutils,
               python3-guestfs,
               python3-libarchive-c,
               python3-magic,
               python3-pytest,
               python3-rpm,
               python3-setuptools,
               python3-tlsh (>= 3.4.1),
               vim-common
Standards-Version: 3.9.7
Homepage: https://diffoscope.org/
Vcs-Git: https://anonscm.debian.org/git/reproducible/diffoscope.git
Vcs-Browser: https://anonscm.debian.org/git/reproducible/diffoscope.git
XS-Testsuite: autopkgtest

Package: diffoscope
Architecture: all
Depends: python3-pkg-resources,
         ${misc:Depends},
         ${python3:Depends},
Recommends: ${diffoscope:Recommends},
            ${python3:Recommends},
Suggests: libjs-jquery
Breaks: debbindiff (<< 29)
Replaces: debbindiff (<< 29)
Description: in-depth comparison of files, archives, and directories
 diffoscope will try to get to the bottom of what makes files or directories
 different. It will recursively unpack archives of many kinds and transform
 various binary formats into more human readable form to compare them. It can
 compare two tarballs, ISO images, or PDF just as easily. The differences can
 be shown in a text or HTML report.
 .
 diffoscope is developed as part of the “reproducible builds” Debian
 project and was formerly known as “debbindiff”.

Package: debbindiff
Depends: diffoscope, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed once
 callers have been update to use 'diffoscope' instead of 'debbindiff'.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 VERSION = $(shell dpkg-parsechangelog --show-field Version)
 
 %:
-	dh $@ --with python2 --buildsystem=pybuild
+	dh $@ --with python3 --buildsystem=pybuild
 
 override_dh_auto_build:
 	@if ! grep -q 'VERSION = "$(VERSION)"' diffoscope/__init__.py; then \
@@ -12,9 +12,12 @@
 	fi
 	dh_auto_build -O--buildsystem=pybuild
 
+override_dh_python3:
+	dh_python3 --recommends=python-debian --recommends=rpm-python --recommends=tlsh --recommends=guestfs
+
 override_dh_gencontrol:
-	TOOLS="$$(bin/diffoscope --list-tools | tail -n 1 | \
-		sed -e 's/\(^\| \)\(coreutils\|diffutils\|e2fsprogs\|findutils\|gzip\)\(,\|$$\)//g')"; \
+	TOOLS="$$(bin/diffoscope --list-tools=debian | tail -n 1 | \
+		sed -e 's/\(^\| \)\(coreutils\|diffutils\|e2fsprogs\|findutils\|gzip\|tar\)\(,\|$$\)//g')"; \
 		[ -n "$$TOOLS" ] || { echo '--list-tools failed' >&2; exit 1; }; \
 		echo "diffoscope:Recommends=$$TOOLS" >> debian/diffoscope.substvars
 	dh_gencontrol -O--buildsystem=pybuild

=== debian/tests/control ===
Tests: pytest
Depends: diffoscope, python3-pytest
Restrictions: needs-recommends

Test-Command: debian/tests/pytest
Depends: diffoscope, python3-pytest
# but without Recommends

Tests: basic-command-line
Depends: diffoscope
# without Recommends

## diffoscope 52~bpo8+1

=== debian/changelog ===
diffoscope (52~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Add myself to uploaders.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 26 Apr 2016 10:43:26 +0000

diffoscope (52) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * debian/gbp.conf: add a conf to have gbp tag the releases how we like them.

  [ Holger Levsen ]
  * Drop transitional debbindiff package.
  * debian/control: Drop XS-Prefix from Testsuite: field, thanks lintian.
  * Mention --max-report-size only once in the manpage. (Closes: #819956)

  [ Satyam Zode ]
  * Fix typo in documentation.

  [ Reiner Herrmann ]
  * Bump Standards-Version to 3.9.8, no changes required.
  * Let objdump demangle symbols for better readability.
  * Install bin/diffoscope instead of auto-generated script. (Closes: #821777)

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 20 Apr 2016 20:28:03 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Reproducible builds folks <reproducible-builds@lists.alioth.debian.org>
 Uploaders:
+ Holger Levsen <holger@debian.org>,
+ Mattia Rizzolo <mattia@debian.org>,
  Reiner Herrmann <reiner@reiner-h.de>,
- Holger Levsen <holger@debian.org>
 Build-Depends: binutils-multiarch,
                debhelper (>= 9),
                dh-python,
@@ -19,11 +20,11 @@
                python3-setuptools,
                python3-tlsh (>= 3.4.1),
                vim-common
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: https://diffoscope.org/
 Vcs-Git: https://anonscm.debian.org/git/reproducible/diffoscope.git
 Vcs-Browser: https://anonscm.debian.org/git/reproducible/diffoscope.git
-XS-Testsuite: autopkgtest
+Testsuite: autopkgtest
 
 Package: diffoscope
 Architecture: all
@@ -43,13 +44,4 @@
  be shown in a text or HTML report.
  .
  diffoscope is developed as part of the “reproducible builds” Debian
- project and was formerly known as “debbindiff”.
-
-Package: debbindiff
-Depends: diffoscope, ${misc:Depends}
-Architecture: all
-Priority: extra
-Section: oldlibs
-Description: transitional package
- This is a transitional package. It can safely be removed once
- callers have been update to use 'diffoscope' instead of 'debbindiff'.
+ project.

## diffoscope 54~bpo8+1

=== debian/changelog ===
diffoscope (54~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 06 Jun 2016 14:44:27 +0000

diffoscope (54) unstable; urgency=medium

  * Fix syntax in RequiredToolNotFound.PROVIDERS.  This caused --list-tools to
    miss entries, and by it missing Recommends in the Debian package.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 03 Jun 2016 16:16:02 +0000

diffoscope (53) unstable; urgency=medium

  [ Reiner Herrmann ]
  * In the directory comparator, fall back to current directory instead of
    empty name. (Closes: #820624)
  * Improve deb(5) support. (Closes: #818414)

  [ Mattia Rizzolo ]
  * debian/control: add myself to Uploaders.
  * Clean up temporary debuglink files.
  * Fix FileNotFoundError with broken symlinks. (Closes: #818856)
  * Decode Md5sumsFile in utf-8. (Closes: #823874)
  * Always suffix temporary files with '_diffoscope'.
  * Rewrite sanity check for the version to always run every time debian/rules
    is invoked, not only during a binary build.

  [ Ed Maste ]
  * Add FreeBSD packages for required tools.

  [ Ceridwen ]
  * Add README.rst to MANIFEST.in.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 03 Jun 2016 14:23:16 +0000

## diffoscope 54

=== debian/control ===
Source: diffoscope
Section: devel
Priority: optional
Maintainer: Reproducible builds folks <reproducible-builds@lists.alioth.debian.org>
Uploaders:
 Holger Levsen <holger@debian.org>,
 Mattia Rizzolo <mattia@debian.org>,
 Reiner Herrmann <reiner@reiner-h.de>,
Build-Depends:
 binutils-multiarch,
 debhelper (>= 9),
 dh-python,
 python3-all,
 python3-debian,
 python3-docutils,
 python3-guestfs,
 python3-libarchive-c,
 python3-magic,
 python3-pytest,
 python3-rpm,
 python3-setuptools,
 python3-tlsh (>= 3.4.1),
 vim-common,
Standards-Version: 3.9.8
Homepage: https://diffoscope.org/
Vcs-Git: https://anonscm.debian.org/git/reproducible/diffoscope.git
Vcs-Browser: https://anonscm.debian.org/git/reproducible/diffoscope.git
Testsuite: autopkgtest

Package: diffoscope
Architecture: all
Suggests: libjs-jquery
Breaks: debbindiff (<< 29)
Replaces: debbindiff (<< 29)
Depends:
 python3-pkg-resources,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 ${diffoscope:Recommends},
 ${python3:Recommends},
Description: in-depth comparison of files, archives, and directories
 diffoscope will try to get to the bottom of what makes files or directories
 different. It will recursively unpack archives of many kinds and transform
 various binary formats into more human readable form to compare them. It can
 compare two tarballs, ISO images, or PDF just as easily. The differences can
 be shown in a text or HTML report.
 .
 diffoscope is developed as part of the “reproducible builds” Debian
 project.

=== debian/rules ===
--- 
+++ 
@@ -1,16 +1,14 @@
 #!/usr/bin/make -f
 
-VERSION = $(shell dpkg-parsechangelog --show-field Version)
+VERSION_dch := $(shell dpkg-parsechangelog --show-field Version)
+VERSION_py := $(shell awk '/^VERSION = / {gsub(/"/, "", $$3); print $$3}' diffoscope/__init__.py )
+
+ifneq ($(VERSION_dch),$(VERSION_py))
+ $(error "Version in debian/changelog doesn't match diffoscope version")
+endif
 
 %:
 	dh $@ --with python3 --buildsystem=pybuild
-
-override_dh_auto_build:
-	@if ! grep -q 'VERSION = "$(VERSION)"' diffoscope/__init__.py; then \
-		echo "Version in debian/changelog doesn't match diffoscope version"; \
-		exit 1; \
-	fi
-	dh_auto_build -O--buildsystem=pybuild
 
 override_dh_python3:
 	dh_python3 --recommends=python-debian --recommends=rpm-python --recommends=tlsh --recommends=guestfs

## diffoscope 55~bpo8+1

=== debian/changelog ===
diffoscope (55~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 22 Jul 2016 12:38:47 +0000

diffoscope (55) unstable; urgency=medium

  [ anthraxx ]
  * Fix sqlite3 magic recognition when using file >= 5.27. (Closes: #830434)

  [ Satyam Zode ]
  * Add argument completion feature to diffoscope. (Closes: #826711)

  [ Chris Lamb ]
  * Improve message when data differs. (Closes: #827981)

  [ Reiner Herrmann ]
  * Clarify the input arguments. (Closes: #826894)

  [ Holger Levsen ]
  * Add link to homepage in HTML output.

  [ Rainer Müller ]
  * python-magic >=0.4.12 does not require decode.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 15 Jul 2016 21:50:29 +0200

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,11 @@
  Mattia Rizzolo <mattia@debian.org>,
  Reiner Herrmann <reiner@reiner-h.de>,
 Build-Depends:
+ bash-completion,
  binutils-multiarch,
  debhelper (>= 9),
  dh-python,
+ python-argcomplete,
  python3-all,
  python3-debian,
  python3-docutils,

=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,10 @@
 endif
 
 %:
-	dh $@ --with python3 --buildsystem=pybuild
+	dh $@ --with python3 --with bash-completion --buildsystem=pybuild
 
 override_dh_python3:
-	dh_python3 --recommends=python-debian --recommends=rpm-python --recommends=tlsh --recommends=guestfs
+	dh_python3 --recommends=python-debian --recommends=rpm-python --recommends=tlsh --recommends=guestfs --recommends=argcomplete
 
 override_dh_gencontrol:
 	TOOLS="$$(bin/diffoscope --list-tools=debian | tail -n 1 | \
@@ -23,12 +23,14 @@
 debian/diffoscope.1: debian/diffoscope.1.rst
 	rst2man $< $@
 
+debian/diffoscope.bash-completion:
+	register-python-argcomplete diffoscope > $@
+
+override_dh_auto_build: debian/diffoscope.bash-completion debian/diffoscope.1
+	dh_auto_build -O--buildsystem=pybuild
+
 override_dh_installman: debian/diffoscope.1
 	dh_installman -O--buildsystem=pybuild
-
-override_dh_clean:
-	rm -f debian/diffoscope.1
-	dh_clean -O--buildsystem=pybuild
 
 diffoscope/presenters/icon.py: favicon.png
 	(echo '# Generated from favicon.png'; \

## diffoscope 56~bpo8+1

=== debian/changelog ===
diffoscope (56~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 01 Aug 2016 20:31:58 +0000

diffoscope (56) unstable; urgency=medium

  [ Jérémy Bobbio ]
  * Fix maybe_decode() so that it actually works.

  [ Chris Lamb ]
  * Mask EPIPE to avoid ugly tracebacks when eg. prematurely terminating $PAGER.
  * Add git index file comparator.
  * Drop unused imports in Ar comparator.

  [ Ximin Luo ]
  * Add support for AR archives (including Rust .rlib files).
  * Add some more documentation for ArFile/ArContainer.
  * RequiredToolNotFound.PROVIDERS dict values are package names, not binary
    names.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 28 Jul 2016 00:02:56 +0200

## diffoscope 59~bpo8+1

=== debian/changelog ===
diffoscope (59~bpo8+1) jessie-backports; urgency=medium

  * Build depend on default-jdk instead of default-jdk-headless,
    not available in jessie-backports.
  * Remove options not recognized by jessie's pybuild.
  * Rebuild for jessie-backports.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 21 Aug 2016 17:01:29 +0000

diffoscope (59) unstable; urgency=medium

  [ Chris Lamb ]
  * SquashFS test_testing:
    - Don't assume that user and group are 5 characters long in squashfs
      test_listing.
    - Drop test test; simply too unreliable and/or has too many requirements to
      satisfy (eg. shorter usernames) for it to not be skipped.
  * Difference class:
    - Ensure that we pass str instances to our Difference class as paths,
      otherwise we can't be sure we can render them. For example, passing a
      class here breaks the HTML renderer.
    - Add test for type checking of path1/path2/source.
    - Pass a str for the path in the JSON comparator, fixing the HTML reporting
      of JSON output.
  * When looping over JQUERY_SYSTEM_LOCATIONS, actually use the variable we are
    looping with when performing the symlink(2) call.
  * trydiffoscope:
    - Add manpage for trydiffoscope.
    - Write trydiffoscope console output as UTF-8, even if STDOUT claims it
      doesn't support it.
  * debian/rules:
    - Make separate calls to dh_python3 for diffoscope and trydiffoscope to
      avoid both getting the same Recommends substvar.
    - Use a pattern-based rule for rst2man-based manpages instead of
      hard-coding "diffoscope.1".
    - Dynamically calculate manpages to generate over hardcoding.
  * .gitignore: Ignore all generated manpages, not just diffoscope.1.

  [ Holger Levsen ]
  * ./CONTRIBUTING:
    - Add new file.
    - Explain what to look out for when uploading diffoscope.

 -- Chris Lamb <lamby@debian.org>  Mon, 15 Aug 2016 09:54:48 +0100

diffoscope (58) unstable; urgency=medium

  * Shorten Description of trydiffoscope to appease Lintian.
  * Make squashfs test_listing test more robust:
    - Add ".in" suffix to squashfs listing expected diff as we are about to
      template it properly.
    - Replace $USER with the current user with uid 1000.
    - Move test_listing replacements to a loop so we can easily add more.
    - Don't assume that the test environment as 4 CPUs in squashfs.test_listing
    - Don't assume default group is the same name as the user in test_listing.

 -- Chris Lamb <lamby@debian.org>  Sun, 14 Aug 2016 10:22:19 +0100

diffoscope (57) unstable; urgency=medium

  [Chris Lamb]
  * Add myself to Uploaders.
  * Add try.diffoscope.org command-line client in new binary package
    "trydiffoscope" to save installation of dependencies:
    - Open files in binary mode to support comparing binary files.
    - Optionally open URL in web browser.
    - Optionally poll locally until result is available.
    - Move to version 2 of API, don't continue to poll on error.
    - Correct and improve help text.
  * Code cleanups:
    - Tidy PROVIDERS dict in diffoscope/__init__.py.
    - Tidy OS_NAMES dict.
    - Correct indentation levels in various files.
    - Drop unused imports.
    - platform.get_linux_distribution() will break in Python 3.7.
    - Don't name first argument of Difference.from_command "cls" as it's not a
      classmethod.
    - comparators/directory.py: Call logger.warning over logger.warn.
    - Rename diffoscope.__main__ to diffoscope.main as its not a "real" magic
      name.
    - Raise NotImplementedError() instances over NotImplemented classes.
    - Add short option for trydiffoscope --url.
    - Rewrite trydiffoscope to match diffoscope's command-line API.
    - Use keepalive in trydiffoscope client to avoid new HTTP requests.
    - Highlight lines via HTML/CSS when hovering over a line to make it easier
      to visually track.
    - Rename debian/install -> debian/diffoscope.install now we have multiple
      binary packages.
  * Add a JSON comparator.
    - Add tests for JSON comparator.
    - Move parsing to JSONFile.recognizes
    - Ensure decode errors in JSON comparator are not fatal.
  * Ignore /.*eggs and /.cache - they get created when running tests.
  * Reflow long dh_python3 call in debian/rules.
  * Use dict.get fallback to shorten OS_NAMES lookup in --list-tools.
  * --list-tools:
    - Output --list-tools in RFC822 format to make parsing less brittle.
    - Print "no package mapping" in --list-tools to stderr, not stdout.
    - Remove unused ``reduce`` import.
    - Reflow long PROVIDERS lookup.
  * Add .travis.yml from http://travis.debian.net/
  * Don't skip squashfs test_listing test; we can workaround it, as long as we
    have a uid 1000.
  * Drop "Testsuite: autopkgtest" in debian/control; it is added automatically
    by dpkg-source version 1.17.11.

  [Mattia Rizzolo]
  * autopkgtest: be more verbose when running the tests
  * debian/control:
    - Mark build-dependency needed only for tests with a <build profile
      (reverted as they break dh-python)
    - add more build-dependencies to be able to run more tests at build time
    - default-jdk-headless is enough to have javap, instead of all of
      default-jdk
  * debian/rules:
    - be more verbose when running the tests, in particular, show why tests are
      being skipped
    - teach pybuild where to put diffoscope's files
  * do not try to execute the command if the command is not available

  [Ximin Luo]
  * Add support for reading LLVM bitcode files
    - Ignore line numbers because different llvm-dis versions output extra
      metadata
    - Disable the llvm-dis test if the version is lower than 3.8
  * Add support for reading Rust LLVM object files
  * Add test for rlib files, helping also to test ArFile, LlvmBitCodeFile and
    RustObjectFile
  * Fix failing directory test
  * Add support for reading the symbol table to ArFile
  * Fix typo in tool_older_than
    - Remove debugging print from tool_older_than

  [anthraxx]


=== debian/control ===
--- 
+++ 
@@ -3,14 +3,25 @@
 Priority: optional
 Maintainer: Reproducible builds folks <reproducible-builds@lists.alioth.debian.org>
 Uploaders:
+ Chris Lamb <lamby@debian.org>,
  Holger Levsen <holger@debian.org>,
  Mattia Rizzolo <mattia@debian.org>,
  Reiner Herrmann <reiner@reiner-h.de>,
 Build-Depends:
  bash-completion,
  binutils-multiarch,
+ caca-utils,
+ colord,
  debhelper (>= 9),
+ default-jdk,
  dh-python,
+ enjarify,
+ fp-utils,
+ ghostscript,
+ llvm,
+ mono-utils,
+ pdftk,
+ poppler-utils,
  python-argcomplete,
  python3-all,
  python3-debian,
@@ -22,18 +33,25 @@
  python3-rpm,
  python3-setuptools,
  python3-tlsh (>= 3.4.1),
+ rpm2cpio,
+ sng,
+ sqlite3,
+ squashfs-tools,
+ unzip,
  vim-common,
 Standards-Version: 3.9.8
 Homepage: https://diffoscope.org/
 Vcs-Git: https://anonscm.debian.org/git/reproducible/diffoscope.git
 Vcs-Browser: https://anonscm.debian.org/git/reproducible/diffoscope.git
-Testsuite: autopkgtest
 
 Package: diffoscope
 Architecture: all
-Suggests: libjs-jquery
-Breaks: debbindiff (<< 29)
-Replaces: debbindiff (<< 29)
+Suggests:
+ libjs-jquery,
+Breaks:
+ debbindiff (<< 29),
+Replaces:
+ debbindiff (<< 29),
 Depends:
  python3-pkg-resources,
  ${misc:Depends},
@@ -50,3 +68,21 @@
  .
  diffoscope is developed as part of the “reproducible builds” Debian
  project.
+
+Package: trydiffoscope
+Architecture: all
+Depends:
+ python3-requests,
+ ${misc:Depends},
+ ${python3:Depends},
+Description: in-depth comparison of files, archives, etc. (try.diffoscope.org client)
+ diffoscope will try to get to the bottom of what makes files or directories
+ different. It will recursively unpack archives of many kinds and transform
+ various binary formats into more human readable form to compare them. It can
+ compare two tarballs, ISO images, or PDF just as easily. The differences can
+ be shown in a text or HTML report.
+ .
+ diffoscope is developed as part of the “reproducible builds” Debian
+ project.
+ .
+ This package contains the https://try.diffoscope.org/ command-line client.

=== debian/rules ===
#!/usr/bin/make -f

MANPAGES = $(patsubst %.1.rst,%.1,$(wildcard debian/*.1.rst))
VERSION_dch := $(shell dpkg-parsechangelog --show-field Version)
VERSION_py := $(shell awk '/^VERSION = / {gsub(/"/, "", $$3); print $$3}' diffoscope/__init__.py )

ifneq ($(VERSION_dch),$(VERSION_py))
 $(error "Version in debian/changelog doesn't match diffoscope version")
endif

export PYBUILD_DESTDIR = debian/diffoscope

%:
	dh $@ --with python3 --with bash-completion --buildsystem=pybuild

override_dh_python3:
	dh_python3 -p trydiffoscope
	dh_python3 -p diffoscope \
		--recommends=python-debian \
		--recommends=rpm-python \
		--recommends=tlsh \
		--recommends=guestfs \
		--recommends=argcomplete

override_dh_gencontrol:
	TOOLS="$$(bin/diffoscope --list-tools=debian | awk -F': ' '/Available-in-Debian-packages/ { print $$2 }' | \
		sed -e 's/\(^\| \)\(coreutils\|diffutils\|e2fsprogs\|findutils\|gzip\|tar\)\(,\|$$\)//g')"; \
		[ -n "$$TOOLS" ] || { echo '--list-tools failed' >&2; exit 1; }; \
		echo "diffoscope:Recommends=$$TOOLS" >> debian/diffoscope.substvars
	dh_gencontrol -O--buildsystem=pybuild

debian/%.1: debian/%.1.rst
	rst2man $< $@

debian/diffoscope.bash-completion:
	register-python-argcomplete diffoscope > $@

override_dh_auto_build: debian/diffoscope.bash-completion $(MANPAGES)
	dh_auto_build -O--buildsystem=pybuild

override_dh_installman: $(MANPAGES)
	dh_installman -O--buildsystem=pybuild

diffoscope/presenters/icon.py: favicon.png
	(echo '# Generated from favicon.png'; \
	 echo 'FAVICON_BASE64 = """'; \
	 base64 $<; \
	 echo '""".replace("\\n", "")'; \
	) > $@

favicon.png: logo.svg
	inkscape -w 32 -h 32 -e $@ $<

## diffoscope 60~bpo8+1

=== debian/changelog ===
diffoscope (60~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Backport from the master branch:
    + d/rules: makes possible to do a backport without changing the version
      "upstream".
  * Skip some tests that fails in jessie-backports.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 17 Sep 2016 13:24:00 +0000

diffoscope (60) unstable; urgency=medium

  [ Chris Lamb ]
  * debian/rules:
    +  Run tests with python3-coverage and generate reports post-build.
  * CONTRIBUTING: Add PyPI reference.
  * Comparators:
    + Avoid ugly DRY violations in diffoscope.comparators.__init__ by
      dynamically importing classes via a single list.
    + git: Specify paths as strings as required since b7830b5cb.
    + elf:
      - Mask more warnings (eg. "readelf: Error: the dynamic segment offset" or
        "size exceeds the size of the file").
      - Specify string format arguments as logging function parameters, not
        using interpolation.
    + json: Correct behaviour of JSON comparator when file does not exist.
  * Presenters:
    + html:
      - Use html.escape over xml.sax.saxutils.escape.
      - Don't use unsafe cgi.escape method as its ``quote`` kwarg — which
        enables escaping of quotation marks — is False by default.
  * Code clean-up:
    + Tidy imports.
    + Split exceptions out into dedicated diffoscope.exc module.
    + Use try-except idiom instead of ``if`` in RequiredToolNotFound.get_package
    + Prefer kwargs[x] = kwargs.pop(x, 'default') idiom over ``if`` statements.
  * tests:
    + Factor out ugly os.path.join to a utility method.
    + Drop unused try_except in tests/conftest.
    + Add GitIndex tests to bring coverage of comparators/git.py to 100%.
    + Add tests for Haskell comparator.
      - Skip Haskell tests if GHC is not installed.
      - Skip Haskell tests if GHC version does not match.  Closes: #835055
    + Add test in JSON comparator for non-existing files.
    + Rewrite lengthy "[..] skipIf [..] tool_missing" with a
      @skip_unless_tools_exist decorator.
    + Add tests for skip_unless_tools_exist helper.
    + Rename tests/comparators/conftest.py -> tests/comparators/utils.py.
    + Avoid Don't-Repeat-Yourself violations by factoring out fixture loading.
    + Avoid more DRY violations by factoring-out non-existing file tests.
    + Remove some other unused imports from comparator tests.
    + Check rendering of text and HTML presenters when checking non-existing
      files.
    + Use `pytest.xfail` over `assert False`.

  [ Mattia Rizzolo ]
  * debian/control:
    + Reinstated build profiles, now that dh-python is fixed (see #834238).
    + Version the build-dependency on dh-python, so it supports build profiles.
    + Add more nocheck build profiles.
    + Bump dependencies on debhelper and dpkg-dev to assure build profile
      support is available.
    + Add Build-Dependency on fontforge-extras for showttf (run during tests)
    + Alternate Build-Dependency on default-jdk-headless|default-jdk, to ease
      backporting to older Debian releases.
  * debian/rules:
    + Don't install '/usr/lib/python3/dist-packages/.coverage'.
    + Run the basic-command-line test during package build.
    + Be even more verbose about failing tests.
    + Allow building a mismatching version between diffoscope and the debian
      changelog if the target distribution is UNRELEASED.
  * Comparators
    + ppu:
      - Unbreak ppu_version detection.
      - Put code out of the context manager, it doesn't need to be within.
  * trydiffoscope: add copyright/license header.
  * autopkgtest/basic-command-line:
    + Enable running basic-command-line test without ADTTMP being set.
    + Be a bit more verbose about what is being tested.
    + Also test return code when passing an invalid command line flag.
    + Force LC_ALL=C.UTF-8, so that diffoscope can always output something.
  * test:
    + Factor out a tools_missing() function.
    + Rewrite tool_older_than() into skip_unless_tool_is_older_than().
    + Skip test_squashfs.py.test_superblock if squashfs is too old.
    + Normalize xxd's output so that we can compare jessie's xxd with stretch's.
  * add default-jdk to the alternate packages for javap for Debian;
    default-jdk-headless is not available in older Debian releases.

  [ Satyam Zode ]
  * Ignore differences in .buildinfo if all the other files listed in .changes
    are identical.  In those cases any differences in .buildinfo files are
    irrelevant, and are actually a feature (as it indicates two reproducible
    builds with different environment).

  [ Jérémy Bobbio ]
  * Properly skip tests requiring python-debian when unavailable.

  [ Ximin Luo ]
  * Show the timestamp when logging, to detect which steps take longer.
  * Add a --no-max flag to disable all limits.
  * Have --max-report-size honour 0 to mean "no limit".
  * Comparators:
    + cbfs: only scan whole file when the filename ends with ".rom".
    + binary: Suppress decimal line numbers for xxd output.
  * Increase default --max-diff-input-lines to 2^20 (1048576) from 100000.
  * Rename --no-max-limits to --no-default-limits, a more accurate name.
  * presenters/html: html-dir output:
    + Split large diffs across several child pages.
      Also add some flags so html-dir behaviour is easier to reason about.
    + Use 4 times the given --max-diff-block-lines.
      This way, '--html x.html --html-dir y' gives reasonable output for both.
  * difference:
    + Fix behaviour for max-diff-block-limit=1 and don't report when 0 lines
      are removed.
    + Don't truncate diff output by default, instead add a separate flag
      --max-diff-block-lines-saved (infinite by default) to do so.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 11 Sep 2016 16:14:33 +0000

=== debian/control ===
--- 
+++ 
@@ -9,36 +9,45 @@
  Reiner Herrmann <reiner@reiner-h.de>,
 Build-Depends:
  bash-completion,
- binutils-multiarch,
- caca-utils,
- colord,
- debhelper (>= 9),
- default-jdk,
- dh-python,
- enjarify,
- fp-utils,
- ghostscript,
- llvm,
- mono-utils,
- pdftk,
- poppler-utils,
+ binutils-multiarch <!nocheck>,
+ caca-utils <!nocheck>,
+ colord <!nocheck>,
+ debhelper (>= 9.20141010),
+ default-jdk-headless <!nocheck> | default-jdk <!nocheck>,
+ dh-python (>= 2.20160818~),
+ dpkg-dev (>= 1.17.14),
+ enjarify <!nocheck>,
+ fontforge-extras <!nocheck>,
+ fp-utils <!nocheck>,
+ ghc <!nocheck>,
+ ghostscript <!nocheck>,
+ libjs-jquery <!nocheck>,
+ libjs-jquery-hotkeys <!nocheck>,
+ libjs-jquery-isonscreen <!nocheck>,
+ libjs-jquery-tablesorter <!nocheck>,
+ libjs-jquery-throttle-debounce <!nocheck>,
+ llvm <!nocheck>,
+ mono-utils <!nocheck>,
+ pdftk <!nocheck>,
+ poppler-utils <!nocheck>,
  python-argcomplete,
  python3-all,
- python3-debian,
+ python3-debian <!nocheck>,
  python3-docutils,
- python3-guestfs,
+ python3-guestfs <!nocheck>,
  python3-libarchive-c,
  python3-magic,
- python3-pytest,
- python3-rpm,
+ python3-pytest <!nocheck>,
+ python3-pytest-cov <!nocheck>,
+ python3-rpm <!nocheck>,
  python3-setuptools,
- python3-tlsh (>= 3.4.1),
- rpm2cpio,
- sng,
- sqlite3,
- squashfs-tools,
- unzip,
- vim-common,
+ python3-tlsh (>= 3.4.1) <!nocheck>,
+ rpm2cpio <!nocheck>,
+ sng <!nocheck>,
+ sqlite3 <!nocheck>,
+ squashfs-tools <!nocheck>,
+ unzip <!nocheck>,
+ vim-common <!nocheck>,
 Standards-Version: 3.9.8
 Homepage: https://diffoscope.org/
 Vcs-Git: https://anonscm.debian.org/git/reproducible/diffoscope.git

=== debian/rules ===
--- 
+++ 
@@ -3,12 +3,27 @@
 MANPAGES = $(patsubst %.1.rst,%.1,$(wildcard debian/*.1.rst))
 VERSION_dch := $(shell dpkg-parsechangelog --show-field Version)
 VERSION_py := $(shell awk '/^VERSION = / {gsub(/"/, "", $$3); print $$3}' diffoscope/__init__.py )
+DIST := $(shell dpkg-parsechangelog --show-field Distribution)
 
 ifneq ($(VERSION_dch),$(VERSION_py))
- $(error "Version in debian/changelog doesn't match diffoscope version")
+ ifneq ($(DIST),UNRELEASED)
+  ifneq (,$(filter %-backports,$(DIST)))
+    ifeq ($(VERSION_dch:~bpo8+1=),$(VERSION_py))
+     $(info Building a Debian backport, accepting version mismatch $(VERSION_py) <-> $(VERSION_dch))
+    else
+     $(error Version in debian/changelog does not match diffoscope version or backport policy)
+    endif
+  else
+   $(error Version in debian/changelog does not match diffoscope version)
+  endif
+ endif
 endif
 
+export PATH := $(CURDIR)/bin:$(PATH)
 export PYBUILD_DESTDIR = debian/diffoscope
+export PYBUILD_TEST_ARGS = -vv -r sxX --cov=diffoscope --cov-report=term-missing --cov-report=html
+export PYBUILD_AFTER_TEST = debian/tests/basic-command-line
+export PYBUILD_AFTER_INSTALL=rm -rvf '{destdir}/{install_dir}/htmlcov' '{destdir}/{install_dir}/.coverage'
 
 %:
 	dh $@ --with python3 --with bash-completion --buildsystem=pybuild
